From b86cdee705898e7ceaf9efa9ad4ad6eb1538b82f Mon Sep 17 00:00:00 2001
From: Stephen Gallagher <sgallagh@redhat.com>
Date: Jan 18 2018 16:35:06 +0000
Subject: [PATCH 3/48] First pass at updating the main modulemd.ModuleMetadata


---

diff --git a/modulemd/__init__.py b/modulemd/__init__.py
index 86d43f1..21e8e01 100644
--- a/modulemd/__init__.py
+++ b/modulemd/__init__.py
@@ -58,6 +58,11 @@ from modulemd.components.rpm import ModuleComponentRPM
 from modulemd.filter import ModuleFilter
 from modulemd.profile import ModuleProfile
 
+import gi
+from gi.repository import GLib
+gi.require_version('Modulemd', '0.1')
+from gi.repository import Modulemd
+
 supported_mdversions = ( 1, )
 
 def load_all(f):
@@ -107,30 +112,44 @@ class ModuleMetadata(object):
 
     def __init__(self):
         """Creates a new ModuleMetadata instance."""
-        self.mdversion = max(supported_mdversions)
-        self.name = ""
-        self.stream = ""
-        self.version = 0
-        self.context = ""
-        self.arch = ""
-        self.summary = ""
-        self.description = ""
-        self.eol = None
-        self.module_licenses = set()
-        self.content_licenses = set()
-        self.buildrequires = dict()
-        self.requires = dict()
-        self.community = ""
-        self.documentation = ""
-        self.tracker = ""
-        self.xmd = dict()
-        self.profiles = dict()
+        # Under the hood, we will use the ModulemdModule type
+        self.module = Modulemd.Module()
+
+        self.module.set_mdversion(max(supported_mdversions))
+        self.module.set_name("")
+        self.module.set_stream("")
+        self.module.set_version(0)
+        self.module.set_context("")
+        self.module.set_arch("")
+        self.module.set_summary("")
+        self.module.set_description("")
+        # Don't pre-set EOL, since we don't have a valid value yet
+        # The Modulemd.Module() default initializes it to an appropriate invalid
+        # date.
+        # self.module.set_eol()
+        self.module.set_module_licenses(Modulemd.SimpleSet())
+        self.module.set_content_licenses(Modulemd.SimpleSet())
+        self.module.set_buildrequires({})
+        self.module.set_requires({})
+        self.module.set_community("")
+        self.module.set_documentation("")
+        self.module.set_tracker("")
+        self.module.set_xmd({})
+        self.module.set_profiles({})
+        self.module.set_rpm_api(Modulemd.SimpleSet())
+        self.module.set_rpm_filter(Modulemd.SimpleSet())
+        self.module.set_rpm_buildopts({})
+        self.module.set_rpm_components({})
+        self.module.set_module_components({})
+        self.module.set_rpm_artifacts(Modulemd.SimpleSet())
+
         self.api = ModuleAPI()
         self.filter = ModuleFilter()
         self.buildopts = ModuleBuildopts()
         self.components = ModuleComponents()
         self.artifacts = ModuleArtifacts()
 
+
     def __repr__(self):
         return ("<ModuleMetadata: "
                 "mdversion: {0}, "
@@ -174,9 +193,6 @@ class ModuleMetadata(object):
                         repr(sorted(self.xmd)),
                         repr(sorted(self.profiles)),
                         repr(self.api),
-                        repr(self.filter),
-                        repr(self.components),
-                        repr(self.artifacts)
                 )
 
     def load(self, f):
@@ -184,9 +200,7 @@ class ModuleMetadata(object):
 
         :param str f: File name to load
         """
-        with open(f, "r") as infile:
-            data = infile.read()
-        self.loads(data)
+        self.module = Modulemd.Module.new_from_file(f)
 
     def loads(self, s):
         """Loads metadata from a string.
@@ -469,7 +483,7 @@ class ModuleMetadata(object):
         changed to one of the supported_mdversions to alter the output
         format.
         """
-        return self._mdversion
+        return self.module.get_mdversion()
 
     @mdversion.setter
     def mdversion(self, i):
@@ -477,34 +491,34 @@ class ModuleMetadata(object):
             raise TypeError("mdversion: data type not supported")
         if i not in supported_mdversions:
             raise ValueError("mdversion: document version not supported")
-        self._mdversion = int(i)
+        self.module.set_mdversion(int(i))
 
     @property
     def name(self):
         """A string property representing the name of the module."""
-        return self._name
+        return self.module.get_name()
 
     @name.setter
     def name(self, s):
         if not isinstance(s, str):
             raise TypeError("name: data type not supported")
-        self._name = s
+        self.module.set_name(s)
 
     @property
     def stream(self):
         """A string property representing the stream name of the module."""
-        return self._stream
+        return self.module.get_stream()
 
     @stream.setter
     def stream(self, s):
         if not isinstance(s, str):
             raise TypeError("stream: data type not supported")
-        self._stream = str(s)
+        self.module.set_stream(s)
 
     @property
     def version(self):
         """An integer property representing the version of the module."""
-        return self._version
+        return self.module.get_version()
 
     @version.setter
     def version(self, i):
@@ -512,72 +526,81 @@ class ModuleMetadata(object):
             raise TypeError("version: data type not supported")
         if i < 0:
             raise ValueError("version: version cannot be negative")
-        self._version = i
+        self.module.set_version(i)
 
     @property
     def context(self):
         """A string property representing the context flag of the module."""
-        return self._context
+        return self.module.get_context()
 
     @context.setter
     def context(self, s):
         if not isinstance(s, str):
             raise TypeError("context: data type not supported")
-        self._context = s
+        self.module.set_context(s)
 
     @property
     def arch(self):
         """A string property representing the module artifacts' hardware
         architecture compatibility.
         """
-        return self._arch
+        return self.module.get_arch()
 
     @arch.setter
     def arch(self, s):
         if not isinstance(s, str):
             raise TypeError("arch: data type not supported")
-        self._arch = s
+        self.module.set_arch(s)
 
     @property
     def summary(self):
         """A string property representing a short summary of the module."""
-        return self._summary
+        return self.module.get_summary()
 
     @summary.setter
     def summary(self, s):
         if not isinstance(s, str):
             raise TypeError("summary: data type not supported")
-        self._summary = s
+        self.module.set_summary(s)
 
     @property
     def description(self):
         """A string property representing a detailed description of the
         module."""
-        return self._description
+        return self.module.get_description()
 
     @description.setter
     def description(self, s):
         if not isinstance(s, str):
             raise TypeError("description: data type not supported")
-        self._description = s
+        self.module.set_description(s)
 
     @property
     def eol(self):
         """A datetime.date property representing the module's EOL date.
         May be None if no EOL is defined."""
-        return self._eol
+
+        if not self.module.get_eol():
+            return None
+
+        eol = datetime.date(self.module.get_eol().get_year(),
+                            self.module.get_eol().get_month(),
+                            self.module.get_eol().get_day())
+        return eol
 
     @eol.setter
     def eol(self, o):
         if not isinstance(o, datetime.date) and o is not None:
             raise TypeError("eol: data type not supported")
-        self._eol = o
+
+        d = GLib.Date.new_dmy(o.day, o.month, o.year)
+        self.module.set_eol(d)
 
     @property
     def module_licenses(self):
         """A set of strings, a property, representing the license terms
         of the module itself."""
-        return self._module_licenses
+        return set(sorted(self.module.get_module_licenses().get()))
 
     @module_licenses.setter
     def module_licenses(self, ss):
@@ -586,7 +609,10 @@ class ModuleMetadata(object):
         for s in ss:
             if not isinstance(s, str):
                 raise TypeError("module_licenses: data type not supported")
-        self._module_licenses = ss
+
+        simpleset = Modulemd.SimpleSet()
+        simpleset.set(list(ss))
+        self.module.set_module_licenses(simpleset)
 
     def add_module_license(self, s):
         """Adds a module license to the set.
@@ -595,7 +621,9 @@ class ModuleMetadata(object):
         """
         if not isinstance(s, str):
             raise TypeError("add_module_license: data type not supported")
-        self._module_licenses.add(s)
+        simpleset = self.module.get_module_licenses()
+        simpleset.add(s)
+        self.module.set_module_licenses(simpleset)
 
     def del_module_license(self, s):
         """Removes the supplied license from the module licenses set.
@@ -614,7 +642,7 @@ class ModuleMetadata(object):
     def content_licenses(self):
         """A set of strings, a property, representing the license terms
         of the module contents."""
-        return self._content_licenses
+        return set(sorted(self.module.get_content_licenses().get()))
 
     @content_licenses.setter
     def content_licenses(self, ss):
@@ -623,7 +651,9 @@ class ModuleMetadata(object):
         for s in ss:
             if not isinstance(s, str):
                 raise TypeError("content_licenses: data type not supported")
-        self._content_licenses = ss
+        simpleset = Modulemd.SimpleSet()
+        simpleset.set(list(ss))
+        self.module.set_module_licenses(simpleset)
 
     def add_content_license(self, s):
         """Adds a content license to the set.
@@ -632,7 +662,9 @@ class ModuleMetadata(object):
         """
         if not isinstance(s, str):
             raise TypeError("add_content_license: data type not supported")
-        self._content_licenses.add(s)
+        simpleset = self.module.get_module_licenses()
+        simpleset.add(s)
+        self.module.set_module_licenses(simpleset)
 
     def del_content_license(self, s):
         """Removes the supplied license from the content licenses set.
@@ -655,7 +687,7 @@ class ModuleMetadata(object):
         Keys are the required module names (strings), values are their
         required stream names (also strings).
         """
-        return self._requires
+        return self.module.get_requires()
 
     @requires.setter
     def requires(self, d):
@@ -664,7 +696,7 @@ class ModuleMetadata(object):
         for k, v in d.items():
             if not isinstance(k, str) or not isinstance(v, str):
                 raise TypeError("requires: data type not supported")
-        self._requires = d
+        self.module.set_requires(d)
 
     def add_requires(self, n, v):
         """Adds a required module dependency.
@@ -674,7 +706,9 @@ class ModuleMetadata(object):
         """
         if not isinstance(n, str) or not isinstance(v, str):
             raise TypeError("add_requires: data type not supported")
-        self._requires[n] = v
+        d = self.module.get_requires()
+        d[n] = v
+        self.module.set_requires(d)
 
     update_requires = add_requires
 
@@ -685,12 +719,16 @@ class ModuleMetadata(object):
         """
         if not isinstance(n, str):
             raise TypeError("del_requires: data type not supported")
-        if n in self._requires:
-            del self._requires[n]
+
+        d = self.module.get_requires()
+
+        if n in d:
+            del d[n]
+            self.module.set_requires(d)
 
     def clear_requires(self):
         """Removes all required runtime dependencies."""
-        self._requires.clear()
+        self.module.set_requires(dict())
 
     @property
     def buildrequires(self):
@@ -700,7 +738,7 @@ class ModuleMetadata(object):
         Keys are the required module names (strings), values are their
         required stream names (also strings).
         """
-        return self._buildrequires
+        return self.module.get_buildrequires()
 
     @buildrequires.setter
     def buildrequires(self, d):
@@ -709,7 +747,7 @@ class ModuleMetadata(object):
         for k, v in d.items():
             if not isinstance(k, str) or not isinstance(v, str):
                 raise TypeError("buildrequires: data type not supported")
-        self._buildrequires = d
+        self.module.set_buildrequires(d)
 
     def add_buildrequires(self, n, v):
         """Adds a module build dependency.
@@ -719,7 +757,10 @@ class ModuleMetadata(object):
         """
         if not isinstance(n, str) or not isinstance(v, str):
             raise TypeError("add_buildrequires: data type not supported")
-        self._buildrequires[n] = v
+
+        d = self.module.get_buildrequires()
+        d[n] = v
+        self.module.set_buildrequires(d)
 
     update_buildrequires = add_buildrequires
 
@@ -730,69 +771,83 @@ class ModuleMetadata(object):
         """
         if not isinstance(n, str):
             raise TypeError("del_buildrequires: data type not supported")
-        if n in self._buildrequires:
-            del self._buildrequires[n]
+
+        d = self.module.get_buildrequires()
+
+        if n in d:
+            del d[n]
+            self.module.set_buildrequires(d)
 
     def clear_buildrequires(self):
         """Removes all build dependencies."""
-        self._buildrequires.clear()
+        self.module.set_buildrequires(dict())
 
     @property
     def community(self):
         """A string property representing a link to the upstream community
         for this module.
         """
-        return self._community
+        return self.module.get_community()
 
     @community.setter
     def community(self, s):
         # TODO: Check if it looks like a link, unless empty
         if not isinstance(s, str):
             raise TypeError("community: data type not supported")
-        self._community = s
+        self.module.set_community(s)
 
     @property
     def documentation(self):
         """A string property representing a link to the upstream
         documentation for this module.
         """
-        return self._documentation
+        return self.module.get_documentation()
 
     @documentation.setter
     def documentation(self, s):
         # TODO: Check if it looks like a link, unless empty
         if not isinstance(s, str):
             raise TypeError("documentation: data type not supported")
-        self._documentation = s
+        self.module.set_documentation(s)
 
     @property
     def tracker(self):
         """A string property representing a link to the upstream bug tracker
         for this module.
         """
-        return self._tracker
+        return self.module.get_tracker()
 
     @tracker.setter
     def tracker(self, s):
         # TODO: Check if it looks like a link, unless empty
         if not isinstance(s, str):
             raise TypeError("tracker: data type not supported")
-        self._tracker = s
+        self.module.set_tracker(s)
 
     @property
     def xmd(self):
         """A dictionary property containing user-defined data."""
-        return self._xmd
+        d = dict()
+        for key, value in self.module.get_xmd().items():
+            d[key] = value.unpack()
+        return d
 
     @xmd.setter
     def xmd(self, d):
         if not isinstance(d, dict):
             raise TypeError("xmd: data type not supported")
-        self._xmd = d
+
+        # TODO: implement this
+        return
+
+        self.module.set_xmd(d)
 
     @property
     def profiles(self):
         """A dictionary property representing the module profiles."""
+        # TODO: return the profiles as a dict of ModuleProfile types
+        return {}
+
         return self._profiles
 
     @profiles.setter

